/*+------------------------------------------------------------------+
                                                      bb - %b.mq4 
                               Copyright  2010, Nondisclosure007 
                                               http://no.link.yet 
                                               
http://www.bollingerbands.com/
http://www.bbforex.com/
//+------------------------------------------------------------------+*/
#property copyright "Copyright  2010, Nondisclosure007"
#property link      "http://no.link.yet"

#property indicator_separate_window
#property indicator_buffers 1

//---- input parameters
extern ENUM_TIMEFRAMES    TimeFrame = PERIOD_CURRENT;
extern int                bbPeriod=20;
extern int                bbDeviation=2;
extern ENUM_APPLIED_PRICE bbPrice=PRICE_CLOSE;

double PercentB[];
double trend[];
string indicatorFileName;
bool   returnBars;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
     
   SetIndexStyle(0,DRAW_LINE,STYLE_SOLID,1,Blue);
   IndicatorDigits(Digits+1);
   SetIndexBuffer(0,PercentB);
   SetIndexLabel(0,"%b");
   indicatorFileName = WindowExpertName();
   returnBars        = TimeFrame==-99;
   TimeFrame         = MathMax(TimeFrame,_Period);
   IndicatorShortName(timeFrameToString(TimeFrame)+" %b - Period="+bbPeriod+"    "); 
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1); 
         if (returnBars) { PercentB[0] = limit+1; return(0); }
         if (TimeFrame != Period())
         {
            limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,TimeFrame,indicatorFileName,-99,0,0)*TimeFrame/Period()));
            for (int i=limit; i>=0; i--)
            {
               int y = iBarShift(NULL,TimeFrame,Time[i]);               
                  PercentB[i]  = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,bbPeriod,bbDeviation,bbPrice,0,y);     
            }
         return(0);                
         }
         
   for(int shift=0; shift<limit; shift++)
   {
      double bbUpper=iBands(NULL,0,bbPeriod,bbDeviation,0,bbPrice,MODE_UPPER,shift);
      double bbLower=iBands(NULL,0,bbPeriod,bbDeviation,0,bbPrice,MODE_LOWER,shift);
      PercentB[shift]=((Close[shift]-bbLower)/(bbUpper-bbLower))*100.0; 
   }
   return(0);
  }
//+------------------------------------------------------------------+
//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}